/* GSnes9x -- doc.h: The long long strings.
 * Copyright (C) 1999 Canek Pelez Valds <canek@abulafia.fciencias.unam.mx>
 * README.TXT original from Gary Henderson <gary@snes9x.com>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* doc.h */

/* This is horrible; but I don't need to worry about a funny
   user deleting files :) */

/* Besides, it helps i18n. */

/* And, err, technically, this are NOT global variables...
   they are global 'constants' :) */

/* They are not preceded by 'const' because of gettext. */

char *readme1 =
_("Snes9x: The Portable Super Nintendo Entertainment System Emulator\n"
  "=================================================================\n"
  "v1.20 11-AUG-1999\n"
  "=================\n"
  "\n"
  "Home page: www.snes9x.com\n"
  "\n"
  "Contents\n"
  "========\n"
  "Changes Since Last Release\n"
  "Introduction\n"
  "What's Emulated\n"
  "What's Not\n"
  "What You Will Need\n"
  "Getting Started/Command Line Options\n"
  "Keyboard Controls\n"
  "Joystick Support\n"
  "Netplay Support\n"
  "Super FX\n"
  "SA-1\n"
  "3Dfx Support\n"
  "Problems With ROMs\n"
  "Sound Problems\n"
  "Converting ROM Images\n"
  "Speeding up the Emulation\n"
  "Credits\n"
  "\n"
  "Changes Since Last Release\n"
  "==========================\n"
  "\n"
  "1.21\n"
  "- Finally worked out how character DMA worked on the SA-1 and implemented a\n"
  "  hacky, slow version, but its enough to get the level up screens displaying\n"
  "  correctly on Mario RPG.\n"
  "- Incorporated ZSNES' new optimised Super FX asm code - had to track down and\n"
  "  fix a nasty memory overwrite bug in the code first to get it to work.\n"
  "- Changed sample mixing code to not automatically wrap offsets to\n"
  "  keep inside the sound buffer, external port code is now expected to do that.\n"
  "  Helped me fix a problem in the Windows port that prevented very large sound\n"
  "  buffers from working, which are required for some badly written sound card\n"
  "  drivers.\n"
  "- Corrected a bug in the SA-1 C code where incorrect processor emulation\n"
  "  functions where called if the code was compiled with in-lining turned off.\n"
  "- Fixed crash bug in Super Mario RPG on the level up screen - forgot to mask\n"
  "  the enable bit from the RAM bank register. Thanks to Christian Wolf for\n"
  "  sending me a freeze file which made it easy to find the problem.\n"
  "- Fixed a lockup bug in the window clipping code, if the ROM ever turned off\n"
  "  the sub-screen completely the clipping code would enter an infinite loop.\n"
  "  Fixes The Cartoon Addams.\n"
  "- Made the Daffy Duck NMI fix only enable when Daffy Duck is loaded - fix was\n"
  "  causing problems for Breath Of Fire 1 and 2.\n"
  "1.20\n"
  "- Windows port no longer sets DirectSound to exclusive mode, so its now \n"
  "  possible to hear sound output from Windows apps while Snes9x has focus.\n"
  "- Fixed the freeze file loading and saving on the Windows port.\n"
  "- More GUI settings are saved in the registry on the Windows port now.\n"
  "- Added 3D/FX image scaling/filtering support to the Windows port.\n"
  "- Added the TV mode from the Mac/Linux ports to the Windows port.\n"
  "- Incorporated Kreed's new output image routines into the Windows port that\n"
  "  fixes RGB555 display colour problems. Many thanks to Kreed.\n"
  "- New auto-frame rate timing code on the Windows port, stops the silly speed\n"
  "  up problems when the old code tried to 'catch up' after the emulator had\n"
  "  been paused.\n"
  "- Increased the DirectSound secondary buffer length on the Windows port to\n"
  "  hopefully fix all the static/broken sound output problems some people were\n"
  "  experiencing.\n"
  "- Altered the ZSNES Super FX asm code so the Windows port could use it - all\n"
  "  previous versions of the Windows port were shipped using the C Super FX\n"
  "  emulation code which is a lot slower.\n"
  "- Implemented interpolated and sync-sound options on the Windows port.\n"
  "- Added an image stretch option to the Windows port - stretches the SNES image\n"
  "  to fill the whole screen or the Window. Looks really good on my TNT card \n"
  "  since that chips seems to filter the image as it scales it.\n"
  "- Implemented Windowed mode on the Windows port.\n"
  "- Added special SPC700 cycle timing for Empire Strikes Back.\n"
  "- Fixed the missing polygon problem for Super FX games - thanks to zsknight\n"
  "  for the information.\n"
  "- Implemented SA-1 support required for Mario RPG, Kirby Superstar,\n"
  "  Paradius 3, etc. but since only a good image of Mario RPG exists, I could\n"
  "  only test that game.\n"
  "- Fixed a graphics clip window bug: inverting the area of a clip area that\n"
  "  only consisted of empty bands should become the full width of the screen;\n"
  "  Mario Kart's rear-view mirror display needs it.\n"
  "- Fixed mode 7 render code to use correct z-buffer when rendering onto the\n"
  "  sub-screen. Fixes Final Fantasy V title screen.\n"
  "- Added horizontal offset per tile support in the offset per tile modes 2 \n"
  "  and 6, and switchable horizontal/vertical offset in mode 4. Fixes Chrono \n"
  "  Trigger in several places and Mario All Stars title screens.\n"
  "- Changed SPC700 relative cycle length to 14, needed for Stunt Car Racer.\n"
  "- Enabled immediate triggering of NMI if NMI enable flag set while scan-line\n"
  "  was on first line of v-blank. Needed to fix a background jitter bug in\n"
  "  Daffy Duck: The Marvin Missions.\n"
  "- Altered ROM load code to ignore corrupt ROM map type byte in ROM header,\n"
  "  preventing the code erroneously detecting what it thinks are interleaved \n"
  "  ROMs. Fixes EEK! The cat, Formation Soccer, the corrupt copy of Donkey \n"
  "  Kong Country, ...\n"
  "- Disabled IRQ retriggering if V-IRQ registers set to the current line. Fixes\n"
  "  Chuck Rock.\n"
  "- Fixed missing sprites in Andre Agassi Tennis - writing to low byte only of\n"
  "  the sprite write address register seems to also clear the hi-byte.\n"
  "1.19\n"
  "- Games written by the Japanese software company Human seem to need special\n"
  "  SPC700 sound CPU timing, so the ROM load and reset routines now check the\n"
  "  software author company and adjust the CPU cycle length accordingly.\n"
  "  It gets Clock Tower, Super Fire Pro-wrestling Premium, etc working.\n"
  "- Added ROM check sum calculation and testing code - Snes9x can now detect\n"
  "  pure, corrupt or hacked ROMs.\n"
  "- Noticed a fast way to implement the SNES 4096 colour mode, so I implemented\n"
  "  it. Now the colours in ActRaiser 2 look correct.\n"
  "- Corrected a noise frequency error thanks to information from Takehiro.\n"
  "- Added a 'start in full screen mode' flag to the Linux port.\n"
  "- While debugging the new graphics code I thought of a fast way to implement\n"
  "  the SNES direct colour mode, tried it out and now the colours in Actraiser 2\n"
  "  are correct.\n"
  "- Blast, forgot about the colour window and fixed colour effects. The separate\n"
  "  sub-screen is back again, but all the other graphics speed ups are there.\n"
  "- Now I've got a z-buffer I keep finding other ways to optimise the SNES\n"
  "  graphics rendering - no need for a separate sub-screen, no need to clear\n"
  "  the sub-screen to the fixed colour, no need to waste CPU time on translucency\n"
  "  effects on hidden pixels, no need to completely clear the main-screen to the\n"
  "  back drop colour, etc., etc.\n"
  "- Implemented a software z-buffer and changed the SNES graphics rendering to\n"
  "  use it (required change for future 3D card support). Finally fixes the\n"
  "  sprite-to-sprite priority bug that some games suffer from. Also a big speed\n"
  "  increasing for some games (10 fps+), others are slight losers.\n"
  "- Added code to skip the rendering of completely transparent graphic tiles\n"
  "  rather than comparing each pixel to see if it is transparent; helps the\n"
  "  frame rate a bit on some games.\n"
  "- Added a fixed for Tetris & Dr. Mario - the game didn't like a multi-player 5 \n"
  "  adaptor plugged in to the real SNES when being played, so turned off the\n"
  "  adaptor emulation for this game.\n"
  "- Added hack for Final Fantasy II - if sync sound isn't on, make attack rate of\n"
  "  1ms actually 0ms (old v1.16 behaviour). Causes a slight click but its better\n"
  "  than samples being cut short.\n"
  "- Fixed a clip window area invert bug if the colour window was enabled on\n"
  "  on one window and the other window was being used to clip a background layer.\n"
  "  Fixes the finial (I hope) display problem with Gun Hazard.\n"
  "- Added code to intersect the clip window areas if both a colour window and\n"
  "  a background layer clip window were enabled at the same time. Required by\n"
  "  Gun Hazard.\n"
  "- Forgot to mark graphic clip windows as needing recomputing when the master\n"
  "  colour window inside/outside/on/off/main-screen/sub-screen PPU register was\n"
  "  updated. Was causing display problems for Gun Hazard.\n"
  "- Internal H-DMA execution accelerator pointer variables where not always\n"
  "  being recomputed when started H-DMA part way into a frame. Was causing\n"
  "  display problems for Gun Hazard.\n"
  "- Made H-DMA continue for one extra scan-line to fix a disappearing monster\n"
  "  problem in Dragon Quest 5. Thanks to Alex Jackson for the bug report.\n"
  "- Zoop seems to require volume envelope height reading by the sound CPU to\n"
  "  always return 0 when the channel is in gain mode.\n"
  "- The sound code was ignoring updates to the ADSR volume envelope rates while\n"
  "  one was in progress. Fixed that and now the bird song at the start of\n"
  "  Chrono Trigger sounds correct.\n"
  "- Had to disable the CPU shutdown code for loops reading the horizontal beam\n"
  "  position, it was causing problems for Star Fox. Still no polygons though.\n"
  "- Oops, sound DSP noise output was broken - accidentally deleted an important\n"
  "  line while removing debug code ready for the last release.\n"
  "- Added initial 3Dfx support to the Linux port - basically using the Voodoo\n"
  "  card as a bi-linear filtering, scaling blitter. Actually slightly slower than\n"
  "  TV mode, for non-scrolling images due to poor texture upload speeds to the\n"
  "  card, but the full-screen feature is nice and the speed doesn't drop as more\n"
  "  of the screen changes.\n"
  "1.18\n"
  "- Implemented a sync-sound mode where sound data gets generated in sync with\n"
  "  SPC700 instructions being executed. Finally the sound Williams Arcade\n"
  "  classics can be heard. Also helps slight sound timing problems in many other\n"
  "  games but doesn't fix Mortal Kombat 2 like I thought it would - its \n"
  "  sound routine programmers must have been on drugs or something!\n"
  "- Added interpolated sound - gives low frequency sounds much more bass similar\n"
  "  to a real SNES especially with the playback rate ramped up to 44KHz.\n"
  "- Added on-screen messages as various emulation options are toggled on and off\n"
  "  using the in-game keys.\n"
  "- Fixed a PPU register read bug with the sprite register write position. Thanks\n"
  "  to Takehiro TOMINAGA for the bug report.\n"
  "- Altered the auto-frame skip timing code to only wait and re-sync to the end \n"
  "  of frame when frames haven't been skipped. Again thanks to Takehiro.\n"
  "- Speeded up the colour addition and subtraction code using ideas from\n"
  "  Takehiro.\n"
  "\n"
  "Introduction\n"
  "============\n"
  "\n"
  "Snes9x is a portable, freeware Super Nintendo Entertainment System (SNES)\n"
  "emulator. It basically allows you to play most games designed for the SNES\n"
  "and Super Famicom Nintendo game systems on your PC or Workstation; which\n"
  "includes some real gems that were only ever released in Japan.\n"
  "\n"
  "Snes9x is the result of well over two years worth of part-time hacking,\n"
  "coding, recoding, debugging, divorce, etc. (just kidding about the divorce\n"
  "bit). Snes9x is coded in C++, with three assembler CPU emulation cores on the\n"
  "i386 Linux, DOS and Windows ports.\n"
  "\n"
  "Snes9x is better than a real SNES:\n"
  "o Freeze a game at any position, then restore the game to that exact spot at\n"
  "  a later date - ideal for saving a game just before a difficult bit.\n"
  "o Built-in cheat cartridge.\n"
  "o Built-in peripheral emulation. The SNES mouse, Multi-player 5 and SuperScope\n"
  "  external add-ons are all emulated, they cost extra money with a real SNES.\n"
  "o Stereo sound - yes I know the SNES produced stereo sound, but who actually\n"
  "  paid the inflated price for the special lead just so you could hear it?\n"
  "o No more cartridge contact cleaning!\n"
  "o Some SNES hardware features that be turned on and off during game play,\n"
  "  games might be using one of these features to deliberately make a section\n"
  "  of the game more difficult. Easy, just turn the feature off.\n"
  "o Networked game play.\n"
  "o Alter the speed of SNES games.\n"
  "\n"
  "Snes9x is worse than a real SNES:\n"
  "o Unless your computer is very fast (Pentium II+), some games just can't\n"
  "  hit every frame being rendered and the emulator starts to skip the drawing\n"
  "  of some frames to keep the emulator running at a constant speed - to you\n"
  "  it appears as if the graphics aren't moving as smoothly as they should.\n"
  "o Not all games work; bugs and missing features cause some games to fail to\n"
  "  work or renders them un-playable.\n"
  "o You have to wait for your computer to boot before you can play games,\n"
  "  no waiting on the real SNES!\n"
  "o The SNES has an analog low-pass sound filter that give a nice bass to\n"
  "  all the sounds and music - Snes9x doesn't emulate this. If you have\n"
  "  a posh sound card, you could try fiddling with it mixer controls to produce\n"
  "  a similar effect. Turning on interpolated sound helps a lot.\n"
  "\n"
  "What's Emulated\n"
  "===============\n"
  "- The 65c816 main CPU.\n"
  "- The Sony SPC700 sound CPU.\n"
  "- SNES variable length cycles.\n"
  "- 8 channel DMA and H-DMA (raster effects).\n"
  "- All background modes, 0 to 7.\n"
  "- Sound DSP, with eight 16-bit stereo channels, compressed samples, hardware\n"
  "  attack-decay-sustain-release volume processing, echo, pitch modulation\n"
  "  and digital FIR sound filter.\n"
  "- 8x8, 16x8 and 16x16 tile sizes, flipped in either direction.\n"
  "- 32x32, 32x64, 64x32 and 64x64 screen tile sizes.\n"
  "- H-IRQ, V-IRQ and NMI.\n"
  "- Mode 7 screen rotation, scaling and screen flipping.\n"
  "- Vertical offset-per-tile in modes 2, and 4.\n"
  "- 256x224, 256x239, 512x224, 512x239, 512x448 and 512x478 SNES screen\n"
  "  resolutions.\n"
  "- Sub-screen and fixed colour transparency effects.\n"
  "- Mosaic effect.\n"
  "- Single and dual graphic clip windows, with all four logic combination modes.\n"
  "- Colour effects only inside a window.\n"
  "- 128 8x8, 16x16, 32x32 or 64x64 sprites, flipped in either direction.\n"
  "- SNES palette changes during frame (15/16-bit internal rendering only).\n"
  "- Direct colour mode - uses tile and palette-group data directly as RGB value.\n"
  "- Super FX, a 21/10MHz RISC CPU found in the cartridge of several games.\n"
  "- SNES mouse.\n"
  "- SuperScope (light gun) emulated using computer mouse.\n"
  "- Multi-player 5 - allowing up to five people to play games simultaneously on\n"
  "  games that support that many players.\n"
  "- Game-Genie, Action Replay and Gold Finger cheat codes.\n"
  "- Multiple ROM image formats, with or without a 512 byte copier header.\n"
  "- Single or split images, compressed using gzip, and interleaved in one of two\n"
  "  ways.\n"
  "- Auto S-RAM (battery backed RAM) loading and saving.\n"
  "- Freeze-game support, now portable between different Snes9x ports.\n"
  "- Interpolated sound.\n"
  "\n"
  "What's Not\n"
  "==========\n"
  "- Only partial DSP1 support, enough to play Mario Kart but no more. The DSP1\n"
  "  is a math co-processor chip that was inside the cartridge of some games,\n"
  "  notably Mario Kart and Pilot Wings.\n"
  "- Any other odd chips that manufactures sometimes placed inside the\n"
  "  cartridge to enhance games and as a nice side-effect, also act as an \n"
  "  anti-piracy measure, e.g. S-DD1, C4, etc.\n"
  "- Pseudo hi-res. mode - SNES hardware uses interpolation to give apparent\n"
  "  increase in horizontal resolution, use the TV or 3D/FX modes to get the \n"
  "  same effect.\n"
  "- Mosaic effect on mode 7.\n"
  "- A couple of SPC700 instructions that I can't work exactly out what they \n"
  "  should do.\n"
  "- Fixed colour and mosaic effects in SNES hi-res. (512x448) modes.\n"
  "- Offset-per-tile in mode 6. Luckily I haven't found a game that uses it, yet.\n"
  "\n"
  "What You Will Need\n"
  "==================\n"
  "\n"
  "CPU\n"
  "---\n"
  "Faster the better, but 486DX4 100 minimum when using 8-bit graphics and\n"
  "minimal or no sound, Pentium 166 or higher for transparency effects and\n"
  "Pentium 200 or higher for Super FX and SA-1 games.\n"
  "\n"
  "Memory\n"
  "------\n"
  "16Mb or more for Linux. Sun workstations shouldn't have a problem.\n"
  "\n"
  "Screen\n"
  "------\n"
  "X Window System ports needs an 8, 15, 16, 24 or 32 bit X server running;\n"
  "transparency effects are available at all depths, but don't look good with\n"
  "only an 8-bit display. For maximum emulation speed, have the X server switched\n"
  "to 8-bit and don't enable transparency effects, or 15 or 16-bit with\n"
  "transparency effects enabled.\n"
  "\n"
  "The Linux SVGA port is very limited at the moment due to no 16-bit screen\n"
  "modes being supported on my main development machine. However, the Linux X\n"
  "Window System version now has a full-screen mode, so there's hopefully no need\n"
  "to use the SVGA version.\n"
  "\n"
  "If you want to use the new stage 1 3dfx bi-linear and scaling features of\n"
  "Snes9x, you will need a Voodoo 1, 2 or 3 graphics card and the glide library\n"
  "installing; glide comes with SuSE 6.0 Linux or you can download it from\n"
  "http://glide.xxedgexx.com/3DfxRPMS.html\n"
  "\n"
  "Disk Space\n"
  "----------\n"
  "1Mb for the emulator.\n"
  "\n"
  "Software\n"
  "--------\n"
  "Access to SNES ROM images in *.smc, *.sfc, *.fig or *.1, *.2, or sf32xxxa,\n"
  "sf32xxxb, etc., format otherwise you will have nothing to run!\n"
  "\n"
  "Some home-brewed ROM images can be downloaded from http://www.snes9x.com. To\n"
  "find commerical games, you could try a web search engine and some imagnative\n"
  "use of search strings, alternatively, I've heard http://www.cherryroms.com is\n"
  "good place to try. Please note, it is illegal in most countries to have\n"
  "commercial ROM images without also owning the actual SNES ROM cartridge.\n"
  "\n"
  "Getting Started\n"
  "===============\n"
  "\n"
  "From a shell just type:\n"
  "snes9x <ROM filename>\n"
  "\n"
  "to start the X Window System port or\n"
  "\n"
  "gsnes9x <ROM filename>\n"
  "\n"
  "to start the X Windows System/Voodoo port.\n"
  "\n"
  "ROM images are normally loaded from the directory ./roms. This can be\n"
  "changed by specifying a pathname with the image name or setting the\n"
  "environment variable SNES96_ROM_DIR to point to a different directory.\n"
  "\n"
  "Freeze game files and S-RAM save files are normally read from and written to\n"
  "the directory $HOME/.snes96_snapshots.  This can be changed by setting the\n"
  "environment variable SNES96_SNAPSHOT_DIR to point to a different directory.\n"
  "\n"
  "To enable full-screen mode on the Linux X Window System and SVGA ports, or to\n"
  "use the Voodoo 3D card without the 3dfx Linux kernel driver installed, Snes9x\n"
  "needs special system access permissions to allow it to write directly to video\n"
  "RAM and alter video chipset register values. In the directory where Snes9x is\n"
  "located, typing:\n"
  "\n"
  "su root\n"
  "chown root snes9x gsnes9x\n"
  "chmod 4755 snes9x gsnes9x\n"
  "\n"
  "will give the binaries the required access.\n"
  "\n"
  "As an alternative for the voodoo port, rather than making the binary set-uid\n"
  "root, download and install the 3dfx kernel driver, again available with SuSE\n"
  "Linux 6.0 or download from http://glide.xxedgexx.com/3DfxRPMS.html \n"
  "\n"
  "Lots of command line flags are available:\n"
  "\n");

char *readmeinfo =
_("The info options are used by GSnes9x for the classification\n"
  "of the ROMs.\n"
  "\n"
  "The four entries must be filled.\n");

char *readmesystem =
_("Here you put the Snes9X command, and the Esound command if you choose use Esound\n"
  "support.");

char *readmegraph =
_("Graphics options:\n"
  "-tr or transparency (default: off)\n"
  "   Enable transparency effects, also enables 16-bit screen mode selection.\n"
  "   Transparency effects are automatically enabled if the depth of your X \n"
  "   server is 15 or greater. \n"
  "-16 or -sixteen (default: off)\n"
  "   Enable 16-bit internal screen rendering, allows palette changes but no\n"
  "   transparency effects.\n"
  "-hires or -hi (default: lo-res.)\n"
  "   Enable support for SNES hi-res. and interlace modes. USE ONLY IF GAME\n"
  "   REQUIRES IT (FEW DO) BECAUSE IT REALLY SLOWS DOWN THE EMULATOR.\n"
  "-y or -interpolate (default: off)\n"
  "   Enables \'TV mode\', hires support, 16-bit internal rendering and\n"
  "   transparency effects. TV mode scales the SNES image by x2 by inserting an\n"
  "   extra blended pixel between each SNES pixel and 80% brightness \'scan-lines\'\n"
  "   between each horizontal line. The result looks very nice but needs a fast\n"
  "   machine. Use with the full-screen X mode and a 15 or 16 depth X server,\n"
  "   or the SVGA port for fastest operation.\n"
  "-nms or -nomodeswitch (default: switch modes)\n"
  "   The Linux X Windows System port can change the screen resolution when\n"
  "   switching to full-screen mode so the SNES display fills the whole screen.\n"
  "   Specify this option to stop it if causes you problems.\n"
  "-fullscreen or -fs\n"
  "   Start the emulator in full screen mode, rather than a window on the X11\n"
  "   port if supported by your X server, a suitable screen mode is defined in\n"
  "   your XF86Config file and the snes9x binary has root permissions (see above).\n"
  "-scale or -sc (default: off)\n"
  "   Stretch the SNES display to fit the whole of the computer display.\n"
  "   Linux X Window System full-screen mode or SVGA port only. Use only if you\n"
  "   have a very fast machine.\n"
  "-displayframerate or -dfr\n"
  "   Display a frame rate counter superimposed over the bottom, left-hand corner\n"
  "   of the SNES display. The value before the slash (/) indicates how many\n"
  "   frames per second are being rendered compared to a real SNES, the value of\n"
  "   which is displayed after the slash.\n"
  "\n");

char *readmesound =
_("Sound options:\n"
  "-ns or -nosound\n"
  "   Disable sound CPU emulation and sound output, useful for the few ROMs\n"
  "   where sound emulation causes them to lock up due to timing errors.\n"
  "-sk 0-3 or -soundskip 0-3 (default: 0)\n"
  "   ONLY USED IF SOUND IS DISABLED. \n"
  "-stereo or -st (default: stereo)\n"
  "   Enable stereo sound output.\n"
  "-mono (default: stereo)\n"
  "   Enable mono sound output. Faster, but doesn\'t sound as nice.\n"
  "-r 0-7 or -soundquality or -sq 0-7 (default: 4)\n"
  "   Sound playback rate/quality:\n"
  "       0 - disable sound, 1 - 8192, 2 - 11025, 3 - 16500, 4 - 22050 (default),\n"
  "       5 - 29300, 6 - 36600, 7 - 44000.\n"
  "-envx or -ex (default: off)\n"
  "   Enable volume envelope height reading by the sound CPU. Can cure sound\n"
  "   repeat problems with some games (e.g. Mortal Kombat series), while causing\n"
  "   others to lock if enabled (eg. Bomberman series). Use with -sy option below\n"
  "   to fix the problems this option can otherwise create.\n"
  "-sy or -soundsync\n"
  "   Turns on sound-sync code where sound data is generated in sync with the\n"
  "   emulation of the SNES sound CPU instructions. Slighty slower emulation speed\n"
  "   but helps reduce note and sound effects timing problems and one or two \n"
  "   games actually require this mode, notably Williams Arcade Classics.\n"
  "   Also turns on interpolated sound and envelope height reading.\n"
  "   Pressing the \']\' key during gameplay toggles sound-sync only on and off.\n"
  "-is or -interpolatedsound (default: off)\n"
  "   Turns on interpolated sound. Any samples played at a lower frequency than\n"
  "   the current playback rate (-r option) have additional sample points\n"
  "   computed and played where previously the same sample data was played\n"
  "   repeatedly. Lower frequency sounds have improved bass and sound much less\n"
  "   harsh - I suspect the real SNES does this.\n"
  "   Pressing \'[\' during gameplay toggles the feature on and off.\n"
  "-b size or -buffersize size or -bs size (default: auto-select)\n"
  "   Sound playback buffer size in bytes 128-4096.\n"
  "-nosamplecaching or -nsc or -nc (default: on)\n"
  "   Disable decompressed sound sample caching. Decompressing samples takes time,\n"
  "   slowing down the emulator. Normally the decompressed samples are saved\n"
  "   just in case they need to be played again, but the way samples are stored\n"
  "   and played on the SNES, it can result in a click sound or distortion when\n"
  "   caching samples with loops in them.\n"
  "-noecho or -ne (default: on)\n"
  "   Turn off sound echo and FIR filter effects. Processing these effects can\n"
  "   really slow down a non-MMX Pentium machine due to the number of calculations\n"
  "   required to implement these features.\n"
  "-ratio 1+ or -ra 1+ (default: 2) (OBSOLETE)\n"
  "   Ratio of 65c816 to SPC700 instructions. The value is no longer used\n"
  "   because SPC700 cycle counting is now implemented giving much more acturate \n"
  "   timing.\n"
  "-nomastervolume or -nmv (default: on)\n"
  "   Disable emulation of the sound DSP master volume control. Some ROMs set\n"
  "   the volume level very low requiring you to turn up the volume level of\n"
  "   your speakers introducing more background noise. Use this option to\n"
  "   always have the master volume set on full and to by-pass a bug which\n"
  "   prevents the music and sound effects being heard on Turrican.\n"
  "\n");

char *readmecheat =
_("Cheat options:\n"
  "-gg <code> or -gamegenie <code>\n"
  "   Supply a Game Genie code for the current ROM. Up to 10 codes can be in\n"
  "   affect at once. Game Genie codes for many SNES games are available from:\n"
  "   http://game-genie.nvc.cc.ca.us\n"
  "-ar <code> or -actionreplay <code>\n"
  "   Supply a Pro-Action Reply code for the current ROM. Up to 10 codes can be in\n"
  "   affect at once. At the moment, codes which alter RAM do not work.\n"
  "-gf <code> or -goldfinger <code>\n"
  "   Supply a Gold Finger code for the current ROM. Up to 10 codes can be active\n"
  "   at once.\n"
  "\n");

char *readmespeed =
_("Speed up/slow down options: (See \"Speeding Up The Emulation\")\n"
  "-f <frame skip count> or -frameskip <frame skip count> (default: auto-adjust)\n"
  "   Set this value to deliberately fix the frame skip rate and disable auto-\n"
  "   speed regulation. Use a larger value faster emulation but more jerky\n"
  "   movement and a smaller value for smooth but slower screen updates.\n"
  "   Use \'+\' and \'-\' keys to modify the value during a game.\n"
  "   Ideal for some Super FX games that confuse the auto-adjust code or\n"
  "   for games that deliberately flash the screen every alternate frame.\n"
  "-frametime <time in milliseconds> or -ft <time in milliseconds>\n"
  "   (default: 16.6ms NTSC games and 20ms for PAL games)\n"
  "   If auto-adjust frame skip option is in effect, then the emulator will try\n"
  "   to maintain a constant game and music speed locked to this value by skipping\n"
  "   the rendering of some frames or waiting until the required time is reached.\n"
  "   Increase the value to slow down games, decrease it to speed up games.\n"
  "   During a game the value can be adjusted in millisecond steps by pressing\n"
  "   Shift \'-\' or Shift \'+\'.\n"
  "-h <0-200> or -cycles <0-200>(default: 100)\n"
  "   Percentage of CPU cycles to execute per scan line, decrease value to\n"
  "   increase emulation frame rate. Most ROMs work with a value of 85 or above.\n"
  "-j or -nojoy\n"
  "   Turn off joystick, SideWinder and GrIP detection (joystick polling on the\n"
  "   PC slows the emulator down).\n"
  "\n");

char *readmeformat =
_("ROM image format options:\n"
  "-i or -interleaved (default: auto-detect)\n"
  "   Force interleaved ROM image format.\n"
  "-i2 or -interleaved (default: can\'t be auto-detected)\n"
  "   Force alternate interleaved format (i.e. most Super FX games).\n"
  "-hirom or -fh or -hr (default: auto-detect)\n"
  "   Force Hi-ROM memory map for ROMs where the Hi-ROM header test fails.\n"
  "-lorom or -fl or -lr (default: auto-detect)\n"
  "   Force Lo-ROM memory map for ROMs where the Hi-ROM header test fails)\n"
  "-header or -hd (default: auto-detect)\n"
  "   Force the detection of a ROM image header. Some ROM images have been \n"
  "   hand-edited to remove unused space from the end of the file; if the\n"
  "   resultant image size is not a multiple of 32k then Snes9x can\'t \n"
  "   auto-detect the presense of a 512 byte ROM image header.\n"
  "-noheader or -nhd (default: auto-detect)\n"
  "   Force Snes9x into thinking no ROM image header is present. See -header\n"
  "   above.\n"
  "-p or -pal (default: auto-detect)\n"
  "   Fool ROM into thinking this is a PAL SNES system and adjust frame time\n"
  "   to 20ms (50 frames per second)\n"
  "-n or -ntsc (default: auto-detect)\n"
  "   Fool ROM into thinking this is a NTSC SNES system and adjust frame time\n"
  "   to 16.7ms (60 frames per second)\n"
  "-l or -layering (default: off)\n"
  "   Swap background layer priorities from background involved in sub-screen\n"
  "   addition/subtraction. Can improve some games play-ability - no need to\n"
  "   constantly toggle background layers on and off to read text/see maps, etc.\n"
  "   Toggle feature on and off during game by pressing \'8\'.\n"
  "   Not used if transparency effects are enabled.\n"
  "-l <freeze game file name> or -loadsnapshot <freeze game file name>\n"
  "   Load snapshot file and restart game from saved position.\n"
  "-nh or -nohdma (default: H-DMA enabled)\n"
  "   Turn off the H-DMA emulation. Pressing \'0\' during a game toggles H-DMA on\n"
  "   and off.\n"
  "-n or -nospeedhacks (default: speed hacks)\n"
  "   Turn off a couple of speed hacks. The hacks boost the speed of many ROMs\n"
  "   but cause problems a few ROMs.\n"
  "-nw or -nowindows (default: graphics windows emulated)\n"
  "   Disable graphics windows emulation. Use \'backspace\' key during a game to\n"
  "   toggle the emulation on and off.\n"
  "\n");

char *readmejoystick =
_("Joystick options:\n"
  "-joymap[1|2|3|4] followed by 8 numbers\n"
  "   Specify the SNES joypad buttons to Linux joystick driver buttons mapping for\n"
  "   each of the four supported joypads.\n"
  "   Specify the Linux joystick button number for the corresponding SNES button\n"
  "   in the following order: A, B, X, Y, TL, TR, Start and Select\n"
  "   The default map is: 1 0 4 3 6 7 8 9 \n"
  "   which is suitable for Sidewinder gamepads.\n"
  "-s or -swap\n"
  "   Swap emulated joy-pad 1 and 2 around, pressing \'6\' during a game does the\n"
  "   same thing.\n"
  "-j or -nojoy\n"
  "   Turn off joystick, SideWinder and GrIP detection (joystick polling on the\n"
  "   PC slows the emulator down).\n"
  "\n");
  
char *readme2 =
_("For example, to start a game called \"mario\", with sound, and transparency\n"
  "effects, type:\n"
  "\n"
  "snes9x -tr mario.smc\n"
  "\n"
  "Keyboard Controls\n"
  "=================\n"
  "\n"
  "While the emulator is running:\n"
  "'Escape'                  Quit the emulator\n"
  "'Pause' or 'Scroll Lock'  Pause the emulator\n"
  "Alt+'f' or PrtSc          Toggle the Linux X11 port full-screen mode on and off.\n"
  "\n"
  "Joy-pad 1:\n"
  "'up' or 'u'               Up direction\n"
  "'down', 'j' or 'n'        Down direction\n"
  "'left' or 'h'             Left direction\n"
  "'right' or 'k'            Right direction\n"
  "'a', 'v' or 'q'           TL button\n"
  "'z', 'b' or 'w'           TR button\n"
  "'s', 'm' or 'e'           X button\n"
  "'x', ',' or 'r'           Y button\n"
  "'d', '.' or 't'           A button\n"
  "'c', '/' or 'y'           B button\n"
  "'return'                  Start button\n"
  "'space'                   Select button\n"
  "\n"
  "'Mouse left'              Mouse left button or SuperScope fire button.\n"
  "'Mouse right'             Mouse right button or SuperScope cursor button.\n"
  "\n"
  "'tab'                     SuperScope turbo toggle switch.\n"
  "'`'                       SuperScope pause button.\n"
  "\n"
  "'0'                       Toggle H-DMA emulation on/off.\n"
  "'1'                       Toggle background 1 on/off.\n"
  "'2'                       Toggle background 2 on/off.\n"
  "'3'                       Toggle background 3 on/off.\n"
  "'4'                       Toggle background 4 on/off.\n"
  "'5'                       Toggle sprites (sprites) on/off\n"
  "'6'                       Toggle swapping of joy-pad one and two around\n"
  "'7'                       Rotate between Multi-player 5, mouse on port 1,\n"
  "                          mouse on port 2 and SuperScope emulation.\n"
  "'8'                       Toggle background layer priorities for backgrounds\n"
  "                          involved in sub-screen addition/subtraction.\n"
  "'9'                       Toggle transparency effects on and off - only if\n"
  "                          16-bit screen mode selected.\n"
  "'Backspace'               Toggle emulation of graphics window effects on/off.\n"
  "\n"
  "'-'                       Decrease frame redraw skip rate\n"
  "'+'                       Increase frame redraw skip rate\n"
  "                          The sequence is auto-frame rate adjust, render every\n"
  "                          frame, render 1 frame in two, render 1 frame in three,\n"
  "                          render 1 frame in four, etc.\n"
  "\n"
  "Shift+'-'                 Decrease frame time in 1ms steps.\n"
  "Shift+'+'                 Increase frame time in 1ms steps.\n"
  "                          The frame time value is the average length of time a\n"
  "                          single frame should take to emulate - works only if\n"
  "                          the auto-frame rate adjust is operational.\n"
  "                          The code will skip the rendering of some\n"
  "                          frames in order to try and reach the required value.\n"
  "Shift+'F1-F10'            Quick save a freeze game file.\n"
  "'F1-F10'                  Quick load a freeze game file, restoring a game to an\n"
  "                          exact position.\n"
  "Alt or Ctrl+'F2' or 'F11' Load a game's saved position.\n"
  "Alt or Ctrl+'F3' or 'F12' Save a game's position.\n"
  "\n"
  "Alt or Ctrl+'F4' -> 'F11' Toggle sound channels on/off.\n"
  "Alt or Ctrl+'F12'         Turn on all sound channels.\n"
  "\n"
  "Joystick Support\n"
  "================\n"
  "\n"
  "The Linux port now makes use of the new v1.x joystick kernel drivers written\n"
  "by Vojtech Pavlik (vojtech@ucw.cz) to allow the use of a wide varity of\n"
  "different joystick/joypad types to control SNES games.\n"
  "\n"
  "Older versions of the drivers are included in recent development Linux\n"
  "kernels. Download the lastest driver version from \n"
  "http://atrey.karlin.mff.cuni.cz/~vojtech/joystick/\n"
  "\n"
  "Refer to the documentation that comes with the drivers to enable support for\n"
  "your type of joystick/pad in Snes9x.\n"
  "\n"
  "Netplay Support\n"
  "===============\n"
  "\n"
  "The Linux and UNIX ports of Snes9x support networked game-play, where each\n"
  "player of a multi-player SNES game can be on their own workstation.  Due to\n"
  "the nature in which the emulated SNES games where written and general lack of\n"
  "speed of the Internet, only local-area network game play is usually possible.\n"
  "\n"
  "Start the s9xserver process on one machine, then start snes9x on each\n"
  "workstation giving the extra command-line flag -server <hostname> where\n"
  "<hostname> is the name of the machine where the s9xserver process was started.\n"
  "It is also possible to specify the server name by setting the environment\n"
  "variable S9XSERVER to the server hostname.\n"
  "\n"
  "Snes9x normally uses network port 6096 by default, this can be changed by\n"
  "specifying -port <port num> on the command line of the server and snes9x,\n"
  "or by setting the environment variable S9XPORT.\n"
  "\n"
  "The first snes9x session to connect to the server becomes player 1 and dicates\n"
  "what ROM all other snes9x clients will have to run before connecting to the\n"
  "server. The second client to connect becomes player 2, and so on. As each new\n"
  "snes9x client process connects to the server, existing games in progress are\n"
  "reset to the beginning to keep everyone in sync.\n"
  "\n"
  "Some SNES games randomise game play and screen layout using data from the SNES\n"
  "sound chip, notably the Bomberman series. Since Snes9x doesn't keep the sound\n"
  "generation in exact synchronisation with the CPU emulation (if it did you'd\n"
  "keep hearing breaks in the sound), you find such games can vary the screen\n"
  "layout and baddy movement between Snes9x sessions given that all other\n"
  "external input is identical, thus making it difficult to play multi-player\n"
  "networked sessions with these games. To network play such games, either switch\n"
  "off sound (-ns) or wait until I provide a re-sync option in a future release.\n"
  "\n"
  "Super FX\n"
  "========\n"
  "\n"
  "The Super FX is a 10/21MHz RISC CPU developed by Argonaut Software used as a\n"
  "game enhancer by several game tiles. Support is still a little buggy but most\n"
  "games work very well, if a little slowly. Released SNES Super FX games included\n"
  "Yoshi's Island (best single-player game on SNES, if you like platform games),\n"
  "Doom, Winter Gold, Dirt Trax FX, StarFox, Stunt Race FX and Vortex. If you're\n"
  "lucky, you might find a copy of the unreleased Starfox 2 image floating around.\n"
  "\n"
  "Lots of Super FX ROM images available are in an odd interleaved format that\n"
  "I haven't worked out how to auto-detect. If your ROM image isn't working try\n"
  "using the -i2 command line flag.\n"
  "\n"
  "SA-1\n"
  "====\n"
  "\n"
  "The SA-1 is a fast, custom 65c816 8/16-bit processor, the same as inside the\n"
  "SNES itself, but clocked at 10MHz compared to a maximum of 3.58MHz for the CPU\n"
  "inside the SNES.\n"
  "\n"
  "The SA-1 isn't just a CPU, it also contains some extra circuits developed by\n"
  "Nintendo which includes some very fast RAM, a memory mapper, DMA, several\n"
  "real-time timers, and the region lock-out chip.\n"
  "\n"
  "Snes9x includes emulation of most features of the SA-1, enough to play Mario\n"
  "RPG. The chip seems to be used in several other games that Nintendo released\n"
  "in 1996 and beyond, notably Kirby Superstar and Paradius 3, but since no\n"
  "complete ROM images of these games exist, I'm unable to test if they work on\n"
  "Snes9x.\n"
  "\n"
  "\n"
  "3Dfx Support\n"
  "============\n"
  "\n"
  "Included in this release of Snes9x is stage 1 Voodoo 3d graphics card support.\n"
  "If you run gsnes9x and, it either has root permission or you install the 3dfx\n"
  "kernel driver module, snes9x will use the 3dfx card to scale and interpolate\n"
  "the SNES image to fill your whole monitor screen - the results look very nice.\n"
  "\n"
  "Downloading textures to Voodoo cards isn't particularly fast, and snes9x has\n"
  "to download each software rendered SNES image as a new texture every frame, so\n"
  "using the 3dfx in this way isn't as fast as you might expect or as fast as I'd\n"
  "hoped.\n"
  "\n"
  "However, there is hope. Stage 2 support in future Snes9x versions will\n"
  "dispense with the software rendering stage altogether, and get the 3dfx card\n"
  "to render each frame directly, removing the need to download a large texture\n"
  "each frame and speeding the whole process up; expect a large speed increase,\n"
  "especially when SNES translucency effects are also being used in a game.\n"
  "\n"
  "Problems With ROMs\n"
  "==================\n"
  "\n"
  "If the emulator just displays a black screen for over 10 seconds, then one\n"
  "of the following could be true:\n"
  "\n"
  "1) If its a Super FX game, chances are its in interleaved2 format, try the -i2\n"
  "   switch.\n"
  "2) Someone has edited the Nintendo ROM information area inside the ROM image\n"
  "   and Snes9x can't work out what format ROM image is in. Try playing\n"
  "   around with the ROM options: -i, -fl, -fh, -hd, -nhd.\n"
  "3) The ROM image is corrupt. If you're loading from CD, I know it might\n"
  "   sound silly, but is the CD dirty?\n"
  "4) The original SNES ROM cartridge had additional hardware inside that is not\n"
  "   emulated yet and might never be - e.g. Street Fighter Alpha 2 (S-DD1),\n"
  "   Megaman X2 and Megaman X3 (C4).\n"
  "\n"
  "The following ROMs are known currently not to work with any version of Snes9x:\n"
  "- All DSP 1 games except Mario Kart (e.g. Pilotwings, Ballz 3d, Topgear 3000)\n"
  "- Street Fighter Alpha 2 (missing S-DD1 emulation)\n"
  "- Megaman X2 and X3 (missing C4 emulation)\n"
  "\n"
  "Sound Problems\n"
  "==============\n"
  "\n"
  "No sound coming from any SNES game using Snes9x? Could be any or all of\n"
  "these:\n"
  "\n"
  "- Snes9x couldn't open the sound device (/dev/dsp) when it started (Snes9x\n"
  "  should display an error message), a permissions problem, the device doesn't\n"
  "  exist or some other process already has the sound device open.\n"
  "- The kernel doesn't support your sound hardware (Linux barely supports the\n"
  "  sound card in my new laptop, I'm stuck with 8-bit sound only at the moment).\n"
  "- You haven't got the volume control on your speakers turned down, have you?\n"
  "\n"
  "General sound problems:\n"
  "\n"
  "- Sound samples keep repeating or don't switch off, especially ones\n"
  "  that play lots of speech samples, try -envx (e.g. Mortal Kombat series) or\n"
  "  -sy.\n"
  "- Sound quality is poor on all games. You have a noisy sound card (usually \n"
  "  cheap cards) or one that Linux only supports at 8-bit, turning on \n"
  "  interpolated sound (-is), sound-sync (-sy) and/or increasing the playback\n"
  "  rate (-r 1-7]) will help.\n"
  "\n"
  "Converting ROM Images\n"
  "=====================\n"
  "\n"
  "If you have a ROM image in several pieces, simply rename them so their\n"
  "filename extensions are numbered: e.g. game.1, game.2, etc. Then, when\n"
  "loading the ROM image, just specify the name of the first part; the remaining\n"
  "parts will be loaded automatically.\n"
  "\n"
  "If they are already in the form sf32xxxa, sf32xxxb, etc., you don't even have\n"
  "to rename them; just specify the name of the first part, as above.\n"
  "\n"
  "Emulation speed\n"
  "===============\n"
  "\n"
  "Emulating an SNES is very compute intensive, with its two or three CPUs,\n"
  "an 8 channel digital sound processor with real-time sound sample decompression\n"
  "and stereo sound, two custom graphics processors, etc.\n"
  "\n"
  "If you only have a 486 machine, you will need to stick to using only 8-bit\n"
  "graphics and minimal or no sound:\n"
  "\n"
  "With sound:\n"
  "snes9x -ne -r 1 -m 2 -mono <rom filename>\n"
  "\n"
  "Without sound:\n"
  "snes9x -ns -m 2 <ROM filename>.\n"
  "\n"
  "Disabling the joystick support will also help (-j).\n"
  "\n"
  "For maximum speed, if you're using the X Window System port, make sure your\n"
  "X server is set to depth 8 and transparency effects are not enabled, or your\n"
  "X server is set to depth 15 or 16 if you want transparency effects.\n"
  "\n"
  "If you want to use the TV mode (-y), switching to a full-screen display is\n"
  "usually fastest with the X server set to depth 15 or 16.\n"
  "\n"
  "Don't enable the scale option and don't resize the window on the X Windows\n"
  "port.\n"
  "\n"
  "Users with slower Pentium machines might want to turn off echo and digital\n"
  "FIR filter effects, due to the number of multiply operations needed to\n"
  "implement them. Use -ne option.\n"
  "\n"
  "Got a big throbbing beast of a CPU under the cover of your computer? These\n"
  "options will sort out the men from the boys:\n"
  "snes9x -y -sc -r 7 -sy <ROM filename>\n"
  "\n"
  "Credits\n"
  "-------\n"
  "\n"
  "- Jerremy Koot for all his hard work on current and previous versions of \n"
  "  Snes96, Snes97 and Snes9x.\n"
  "- Ivar for the original Super FX C emulation, DSP1 emulation work and \n"
  "  information on both chips.\n"
  "- zsKnight and _Demo_ for the Intel Super FX assembler code.\n"
  "- zsKnight and _Demo_ for all the other ideas I've nicked off them; they've\n"
  "  nicked lots of my ideas and information too!\n"
  "- DiskDude's SNES Kart v1.6 document for the Game Genie(TM), Gold Finger and\n"
  "  Pro Action Replay cheat system information.\n"
  "- Lord ESNES for some nice chats and generally useful stuff.\n"
  "- Lee Hyde (lee@jlp1.demon.co.uk) for his quest for sound information and \n"
  "  the Windows 95 icon.\n"
  "- Shawn Hargreaves for the rather good Allegro 3.0 DOS library.\n"
  "- Robert Grubbs for the SideWinder information - although I didn't use his\n"
  "  actual driver in the end.\n"
  "- Steve Snake for his insights into SNES sound sample decompression.\n"
  "- Vojtech Pavlik for the Linux joystick driver patches.\n"
  "- Maciej Babinski for the basics of Linux's DGA X server extensions.\n"
  "- Alexander Larsson for the GGI Linux port code.\n"
  "- Harald Fielker for some sound interpolation code (not included in this \n"
  "  release due to problems).\n"
  "- Takehiro TOMINAGA for many speed up suggestions and bug fixes.\n"
  "\n"
  "Nintendo is a trademark.\n"
  "Super NES, SuperScope and Super FX are a trademarks of Nintendo. \n"
  "Sun, Solaris and Sparc are all trademarks of Sun Microsystems, Inc.  \n"
  "Game Genie is a trademark of Lewis Galoob Toys, Inc.\n"
  "MS-DOS and Windows 95 are trademarks of Microsoft Corp.\n"
  "Intel, Pentium and MMX are all trademarks of Intel Corp.\n"
  "Sony is a trademark of Sony Corp.\n"
  "UNIX is a trademark of someone, I forget who, but its not AT&T, they sold it.\n"
  "Glide is a trademark of 3Dfx Interactive, inc.\n"
  "\n"
  "------------------------------------------------------------------------------\n"
  "Gary Henderson\n"
  "gary@snes9x.com\n"
  "\n");
